﻿Imports System
Imports NXOpen

Module transportspindel

   Dim sess As Session
   Dim nxui As UI
   Dim wp As Part
   Dim rootcomp As Assemblies.Component
   Dim exp As Expression
   Dim nrfmt As Globalization.NumberFormatInfo
   Dim cameras(1) As Display.Camera

   Public Sub Main()
      sess = Session.GetSession
      nxui = UI.GetUI

      wp = sess.Parts.Work
      If wp Is Nothing Then Exit Sub

      rootcomp = wp.ComponentAssembly.RootComponent
      If rootcomp Is Nothing Then Exit Sub

      exp = wp.Expressions.FindObject("crvlen")
      If exp Is Nothing Then Exit Sub

      nrfmt = New Globalization.NumberFormatInfo
      nrfmt.NumberDecimalSeparator = "."c

      ReDim cameras(1)
      cameras(0) = wp.Cameras.FindObject("TargetFixed")
      cameras(1) = wp.Cameras.FindObject("ToolFixed")

      Dim stp As Double = 0.5
      Dim orgarr As Assemblies.Arrangement = wp.ComponentAssembly.ActiveArrangement
      Dim usedarr As Assemblies.Arrangement = wp.ComponentAssembly.Arrangements.FindObject("TargetFixed")
      If usedarr IsNot Nothing Then
         If nxui.NXMessageBox.Show("Please select", NXMessageBox.DialogType.Question, {"Fix Target and start Cycle ?"}) = 1 Then
            rootcomp.SetUsedArrangement(usedarr)
            If cameras(0) IsNot Nothing Then cameras(0).ApplyToView(wp.ModelingViews.WorkView)
            CycleExpression(0, 100, stp)
            CycleExpression(100, 0, -stp)
         End If
      End If

      usedarr = wp.ComponentAssembly.Arrangements.FindObject("ToolFixed")
      If usedarr IsNot Nothing Then
         If nxui.NXMessageBox.Show("Please select", NXMessageBox.DialogType.Question, "Fix Tool and start Cycle ?") = 1 Then
            rootcomp.SetUsedArrangement(usedarr)
            If cameras(1) IsNot Nothing Then cameras(1).ApplyToView(wp.ModelingViews.WorkView)
            CycleExpression(0, 100, stp)
            CycleExpression(100, 0, -stp)
         End If
      End If

      usedarr = wp.ComponentAssembly.Arrangements.FindObject("RealMotion")
      If usedarr IsNot Nothing Then
         If nxui.NXMessageBox.Show("Please select", NXMessageBox.DialogType.Question, "Rotate Target and start Transport Cycle ?") = 1 Then
            rootcomp.SetUsedArrangement(usedarr)
            If cameras(0) IsNot Nothing Then cameras(0).ApplyToView(wp.ModelingViews.WorkView)
            CycleExpression(0, 100, stp)
            CycleExpression(100, 0, -stp)
         End If
      End If

      rootcomp.SetUsedArrangement(orgarr)
      nxui.NXMessageBox.Show("Finished", NXMessageBox.DialogType.Information, "Finished cycling.")
   End Sub

   Private Sub CycleExpression(ByVal fromval As Double, ByVal toval As Double, ByVal stp As Double)
      For val As Double = fromval To toval Step stp
         exp.RightHandSide = val.ToString(nrfmt)
         sess.UpdateManager.DoUpdate(sess.NewestVisibleUndoMark)
      Next
   End Sub

End Module
